diff --git a/include/net/cfg80211.h b/include/net/cfg80211.h
index 220d5f5..84378bf 100644
--- a/include/net/cfg80211.h
+++ b/include/net/cfg80211.h
@@ -1512,6 +1512,8 @@ struct cfg80211_sched_scan_request {
 	struct wiphy *wiphy;
 	struct net_device *dev;
 	unsigned long scan_start;
+	u32 owner_nlportid;
+	struct work_struct sched_scan_stop_wk;
 
 	/* keep last */
 	struct ieee80211_channel *channels[0];
diff --git a/include/uapi/linux/nl80211.h b/include/uapi/linux/nl80211.h
index 185f9c7..5038240 100644
--- a/include/uapi/linux/nl80211.h
+++ b/include/uapi/linux/nl80211.h
@@ -1640,6 +1640,9 @@ enum nl80211_commands {
  * @NL80211_ATTR_SOCKET_OWNER: Flag attribute, if set during interface
  *	creation then the new interface will be owned by the netlink socket
  *	that created it and will be destroyed when the socket is closed.
+ *	If set during scheduled scan start then the new scan req will be
+ *	owned by the netlink socket that created it and the scheduled scan will
+ *	be stopped when the socket is closed.
  *
  * @NL80211_ATTR_TDLS_INITIATOR: flag attribute indicating the current end is
  *	the TDLS link initiator.
diff --git a/net/wireless/core.c b/net/wireless/core.c
index a4d2792..9d33df6 100644
--- a/net/wireless/core.c
+++ b/net/wireless/core.c
@@ -850,8 +850,10 @@ void __cfg80211_leave(struct cfg80211_registered_device *rdev,
 		break;
 	case NL80211_IFTYPE_P2P_CLIENT:
 	case NL80211_IFTYPE_STATION:
-		if (rdev->sched_scan_req && dev == rdev->sched_scan_req->dev)
+		if (rdev->sched_scan_req && dev == rdev->sched_scan_req->dev) {
+			flush_work(&rdev->sched_scan_req->sched_scan_stop_wk);
 			__cfg80211_stop_sched_scan(rdev, false);
+		}
 
 #ifdef CONFIG_CFG80211_WEXT
 		kfree(wdev->wext.ie);
@@ -991,6 +993,7 @@ static int cfg80211_netdev_notifier_call(struct notifier_block *nb,
 
 		if (WARN_ON(rdev->sched_scan_req &&
 			    rdev->sched_scan_req->dev == wdev->netdev)) {
+			flush_work(&rdev->sched_scan_req->sched_scan_stop_wk);
 			__cfg80211_stop_sched_scan(rdev, false);
 		}
 
diff --git a/net/wireless/nl80211.c b/net/wireless/nl80211.c
index df447c0..87a4b71 100644
--- a/net/wireless/nl80211.c
+++ b/net/wireless/nl80211.c
@@ -5681,6 +5681,22 @@ static int nl80211_trigger_scan(struct sk_buff *skb, struct genl_info *info)
 	return err;
 }
 
+static void nl80211_sched_scan_stop_wk(struct work_struct *work)
+{
+	struct cfg80211_sched_scan_request *req;
+	struct cfg80211_registered_device *rdev;
+
+	req = container_of(work, struct cfg80211_sched_scan_request,
+			   sched_scan_stop_wk);
+
+	rdev = wiphy_to_rdev(req->wiphy);
+
+	if (rtnl_trylock()) {
+		__cfg80211_stop_sched_scan(rdev, false);
+		rtnl_unlock();
+	}
+}
+
 static int nl80211_start_sched_scan(struct sk_buff *skb,
 				    struct genl_info *info)
 {
@@ -5955,6 +5971,13 @@ static int nl80211_start_sched_scan(struct sk_buff *skb,
 
 	err = rdev_sched_scan_start(rdev, dev, request);
 	if (!err) {
+		if (info->attrs[NL80211_ATTR_SOCKET_OWNER]) {
+			INIT_WORK(&request->sched_scan_stop_wk,
+				  nl80211_sched_scan_stop_wk);
+
+			request->owner_nlportid = info->snd_portid;
+		}
+
 		rdev->sched_scan_req = request;
 		nl80211_send_sched_scan(rdev, dev,
 					NL80211_CMD_START_SCHED_SCAN);
@@ -12127,6 +12150,12 @@ static int nl80211_netlink_notify(struct notifier_block * nb,
 
 	list_for_each_entry_rcu(rdev, &cfg80211_rdev_list, list) {
 		bool schedule_destroy_work = false;
+		bool schedule_scan_stop = false;
+		struct cfg80211_sched_scan_request *req = rdev->sched_scan_req;
+
+		if (req && req->owner_nlportid == notify->portid &&
+		    notify->portid)
+			schedule_scan_stop = true;
 
 		list_for_each_entry_rcu(wdev, &rdev->wdev_list, list) {
 			cfg80211_mlme_unregister_socket(wdev, notify->portid);
@@ -12157,6 +12186,12 @@ static int nl80211_netlink_notify(struct notifier_block * nb,
 				spin_unlock(&rdev->destroy_list_lock);
 				schedule_work(&rdev->destroy_work);
 			}
+		} else if (schedule_scan_stop) {
+			req->owner_nlportid = 0;
+
+			if (rdev->ops->sched_scan_stop &&
+			    rdev->wiphy.flags & WIPHY_FLAG_SUPPORTS_SCHED_SCAN)
+				schedule_work(&req->sched_scan_stop_wk);
 		}
 	}
 